<?php

declare(strict_types=1);

namespace App\Listeners;

use App\Models\ActivityLogNamesEnum;
use Illuminate\Contracts\Queue\ShouldQueue;
use Seka\Vzdelavanie\Events\Testovanie\Frontend\TestVyhodnotenie;

/**
 * Class AktivitaVzdelavanieTestovanieVyhodnotenieTestuPouzivatelom
 */
final class AktivitaVzdelavanieTestovanieVyhodnotenieTestuPouzivatelom implements ShouldQueue
{
    public function handle(TestVyhodnotenie $event): void
    {
        activity()
            ->by($event->pouzivatel)
            ->inLog(ActivityLogNamesEnum::VZDELAVANIE_TESTY->value)
            ->performedOn($event->test)
            ->withProperties([
                'nazov' => $event->test->nazov,
                'vyhodnotenie' => sprintf(
                    'správne odpovede %s z %s',
                    $event->test->pocet_spravne_zodpovedanych_otazok,
                    $event->test->max_pocet_spravnych_odpovedi,
                ),
                'request' => [
                    'ip' => $event->request->get('REMOTE_ADDR'),
                    'user_agent' => $event->request->get('user-agent'),
                ],
            ])
            ->log(get_class($event));
    }
}
